AddCSLuaFile( "cl_init.lua" )
AddCSLuaFile( "shared.lua" )
include( 'shared.lua' )


function ENT:SpawnFunction( ply, tr )

	if ( !tr.Hit ) then return end
	
	local SpawnPos = tr.HitPos + tr.HitNormal * 16
	
	local ent = ents.Create( "syringegun_syringe" )
		ent:SetPos( SpawnPos )
	ent:Spawn()
	ent:Activate()
	
	return ent
	
end

function ENT:PhysicsCollide( data, physobj )
	self:CheckTarget( data )
	return
end

function ENT:CheckTarget( data )
	if data.HitEntity:IsValid() && data.HitEntity:GetClass() != "worldspawn" && !self.Stuck then
		data.HitEntity:TakeDamage( 10, self.Owner )
		self:RemoveDart()
	else
		self.Entity:GetPhysicsObject():EnableMotion( false )
		self.Entity:SetAngles( self.StartAngles )
		self.Stuck = true
	end
end


function ENT:RemoveDart()
	if self.Entity && self.Entity:IsValid() then
		self.Entity:Remove()
		self.Syringe:Remove()
	end
end

function ENT:Initialize()	

	self.Stuck = false
	self.Entity:SetModel( "models/props_junk/PopCan01a.mdl" )
	self.Entity:PhysicsInit( SOLID_VPHYSICS )
	self.Entity:SetMoveType( MOVETYPE_VPHYSICS ) 
	self.Entity:SetSolid( SOLID_VPHYSICS )

	self.Syringe = ents.Create("prop_effect")
	self.Syringe:SetPos( self.Entity:GetPos() )
	self.Syringe:SetAngles( self.Entity:GetAngles() + Angle( -90, 0, 0 ) )
	self.Syringe:SetModel( "models/weapons/w_models/w_syringe_proj.mdl" )
	self.Syringe:Spawn()
	self.Syringe:Activate()
	
	self.Entity:DrawShadow( false )
	self.Syringe:DrawShadow( false )
	
	self.Targets = { "player", "npc_", "prop_" }
	
	self.StartAngles = self.Entity:GetAngles()
	
	self.Syringe:SetParent( self.Entity )

	local phys = self.Entity:GetPhysicsObject()
	if (phys:IsValid()) then
		phys:Wake()
	end
	
	timer.Simple( 10, self.RemoveDart, self )
	
end


