AddCSLuaFile( "cl_init.lua" )
AddCSLuaFile( "shared.lua" )
include( 'shared.lua' )

function ENT:Asplode()

	if !self.Entity || !self.Entity:IsValid() then return end

	local pos = self.Entity:GetPos()
	
	local Efx = EffectData()
	Efx:SetOrigin( pos )
	Efx:SetStart( pos )
	Efx:SetMagnitude( 10 )
	Efx:SetScale( 10 )
	util.Effect( "HelicopterMegaBomb", Efx )
	
	local Efs = EffectData()
	Efs:SetOrigin( pos )
	Efs:SetStart( pos )
	Efs:SetMagnitude( 10 )
	Efs:SetScale( 10 )
	util.Effect( "Explosion", Efs )
	
	local Efd = EffectData()
	Efd:SetOrigin( pos )
	Efd:SetStart( pos )
	Efd:SetMagnitude( 3 )
	Efd:SetScale( 3 )
	util.Effect( "ThumperDust", Efd )
	
	self.Entity:EmitSound( Sound( "Weapon_Grenade_Pipebomb.Explode" ), 500 )
	
	if self.Owner then
		util.BlastDamage( self.Entity, self.Owner, pos, 100, 40 )
	else
		util.BlastDamage( self.Entity, self.Entity, pos, 100, 40 )
	end

	self.Entity:Remove()
	
end

function ENT:Touch( Entity )
	for k,v in pairs( self.Targets ) do
		if string.find( Entity:GetClass(), v ) then
			self:Asplode()
		end
	end
end
 
function ENT:PhysicsCollide( data, physobj )

	//THNX GARRYH
	if (data.Speed > 80 && data.DeltaTime > 0.2 ) then
		self.Entity:EmitSound( Sound( "Weapon_Grenade_Pipebomb.Bounce" ), 500 )
	end
	local LastSpeed = data.OurOldVelocity:Length()
	local NewVelocity = physobj:GetVelocity()
	NewVelocity:Normalize()
	
	LastSpeed = math.max( NewVelocity:Length(), LastSpeed )
	
	local TargetVelocity = NewVelocity * LastSpeed * 0.9
	
	physobj:SetVelocity( TargetVelocity )
end

function ENT:Initialize()	

	self.Rotation = 400
	self.Entity:SetModel( "models/weapons/w_models/w_grenade_grenadelauncher.mdl" )
	self.Entity:PhysicsInit( SOLID_VPHYSICS )
	self.Entity:SetMoveType( MOVETYPE_VPHYSICS ) 
	self.Entity:SetSolid( SOLID_VPHYSICS )

	local phys = self.Entity:GetPhysicsObject()
	if (phys:IsValid()) then
		phys:Wake()
	end
	self.Entity:GetPhysicsObject():AddAngleVelocity( Vector( math.random(-self.Rotation, self.Rotation ), math.random(-self.Rotation, self.Rotation ), math.random(-self.Rotation, self.Rotation) ) )

	timer.Simple( math.random( 1.5, 3 ), self.Asplode, self )
	self.Targets = { "player", "npc_", "prop_vehicle_" }
	
end


