

if ( SERVER ) then

	AddCSLuaFile( "shared.lua" )
	
end

if ( CLIENT ) then

	SWEP.PrintName			= "Sniper's Sniper"			
	SWEP.Author				= "The Mathias"
	SWEP.Slot				= 3
	SWEP.SlotPos			= 1
	SWEP.IconLetter			= "z"
	
	killicon.AddFont( "weapon_sniper", "CSKillIcons", SWEP.IconLetter, Color( 255, 80, 0, 255 ) )
	
end


//SWEP.Base				= "weapon_cs_base"
SWEP.Category			= "Team Fortress 2"

SWEP.Spawnable			= true
SWEP.AdminSpawnable		= true

SWEP.ViewModel			= "models/weapons/v_models/v_sniperrifle_sniper.mdl"
SWEP.WorldModel			= "models/weapons/w_models/w_sniperrifle.mdl"

SWEP.Weight				= 5
SWEP.AutoSwitchTo		= false
SWEP.AutoSwitchFrom		= false

SWEP.Primary.Sound			= Sound( "Weapon_SniperRifle.SingleCrit" )
SWEP.Primary.ClipEmpty		= Sound( "Weapon_SniperRifle.ClipEmpty" )
SWEP.Primary.ChargeTime 	= 3
SWEP.Primary.DotSize 		= 50
SWEP.Primary.ClipSize		= 25
SWEP.Primary.Delay			= 0.15
SWEP.Primary.DefaultClip	= 25
SWEP.Primary.Automatic		= false
SWEP.Primary.Ammo			= "357"

SWEP.Secondary.ClipSize		= -1
SWEP.Secondary.DefaultClip	= -1
SWEP.Secondary.Automatic	= false
SWEP.Secondary.Ammo			= "none"

function SWEP:DrawHUD()
	if self:GetScoped() then	
		surface.SetDrawColor( 255, 255, 255, 255 )
		
		// Upper Left
		surface.SetTexture( self.UL )
		surface.DrawTexturedRectRotated( 0 + ( ScrW() / 4 ), 0 + ( ScrH() / 4 ), ScrW() / 2, ScrH() / 2, 0 )
		
		// Upper Right
		surface.SetTexture( self.UR )
		surface.DrawTexturedRectRotated( ScrW() / 2 + ( ScrW() / 4 ), 0 + ( ScrH() / 4 ), ScrW() / 2, ScrH() / 2, 0 )
		
		// Lower Left
		surface.SetTexture( self.LL )
		surface.DrawTexturedRectRotated( 0 + ( ScrW() / 4 ), ScrH() / 2 + ( ScrH() / 4 ), ScrW() / 2, ScrH() / 2, 0 )
		
		// Lower Right
		surface.SetTexture( self.LR )
		surface.DrawTexturedRectRotated( ScrW() / 2 + ( ScrW() / 4 ), ScrH() / 2 + ( ScrH() / 4 ), ScrW() / 2, ScrH() / 2, 0 )
		
		render.SetMaterial( Material( "sprites/glow02" ) )
		render.DrawSprite( self.Owner:GetEyeTrace().HitPos, 3, 3, Color(255, 0, 0, 255) )
		
		surface.SetTexture( self.Dot )
		surface.SetDrawColor( 255, 0, 0, 50 )
		surface.DrawTexturedRect( ScrW() / 2 - ( self.Primary.DotSize / 2 ), ScrH() / 2 - ( self.Primary.DotSize / 2 ), self.Primary.DotSize, self.Primary.DotSize )
		
		surface.SetDrawColor( 255, 0, 0, 255 )
		local ScopeStart = ( CurTime() - self.Weapon:GetNWInt( "startscope") )
		if ScopeStart > self.Primary.ChargeTime  then
			ScopeStart = self.Primary.ChargeTime 
		end
		
		local Size = ( ScopeStart / self.Primary.ChargeTime ) * self.Primary.DotSize
		Size = math.floor( Size / 2 ) * 2
		surface.DrawTexturedRect( ScrW() / 2 - ( Size / 2 ), ScrH() / 2 - ( Size / 2 ), Size, Size )
		
		surface.SetDrawColor( 255, 255, 0, 100 )
		for i = 5, 50, 5 do
			surface.DrawRect( ( ScrW() / 2 ) + 33 + ( i * 1.2 ), ScrH() / 2, 4, i / 2 )
		end
		
		local Percent = math.floor( ( ScopeStart / self.Primary.ChargeTime ) * 100 )
		surface.SetDrawColor( 255, 255, 0, 255 )
		
		for i = 5, math.floor( ( Percent / 2 ) ), 5 do
			surface.DrawRect( ( ScrW() / 2 ) + 33 + ( i * 1.2 ), ScrH() / 2, 4, i / 2 )
		end
		
		
		surface.SetFont( "ChatFont" )
		surface.SetTextColor( 255, 255, 0, 255 )
		surface.SetTextPos( ( ScrW() / 2 ) + 120, ScrH() / 2 + 5 )
		surface.DrawText( Percent .. "%" )
		
	end
end

function SWEP:ViewModelDrawn()
	if self.Weapon:GetNWBool( "scoped" ) then
		render.SetMaterial( Material( "sprites/redglow1" ) )
		render.DrawSprite( self.Owner:GetEyeTrace().HitPos, 3, 3, Color(255, 0, 0, 255) ) 
	end
end	

function SWEP:HUDShouldDraw( Element )
	if Element == "CHudCrosshair" then
		return false
	end
	return true
end

function SWEP:PrimaryAttack()

	if ( !self:CanPrimaryAttack() ) then return end

	self.NextSecondaryFire = CurTime() + self.Primary.Delay
	self.NextPrimaryFire = CurTime() + self.Primary.Delay
	
	local Dmg
	if self.Scoped then
		Dmg = ( CurTime() - self.StartScope )
		if Dmg > self.Primary.ChargeTime  then
			Dmg = self.Primary.ChargeTime 
		end
	else
		Dmg = 0
	end
	Dmg = 20 + ( Dmg * ( ( self.Primary.ChargeTime / 0.2 ) + 10 ) )
	Force = Dmg / 5
	
	self:CSShootBullet( Dmg, 0, 1, 0, Force )
	
end
function SWEP:SecondaryAttack()
	if self:CanPrimaryAttack() then
		self:SetScoped( !self:GetScoped() )
	end
end

function SWEP:Reload()
end

function SWEP:Deploy()
	self.Weapon:EmitSound( Sound( "Weapon_SniperRifle.Draw" ) )
end

function SWEP:Holster()
	self:SetScoped( false )
	return true
end
function SWEP:Initialize()
	if SERVER then self:SetWeaponHoldType( "rpg" ) end
	self.NextPrimaryFire = CurTime()
	timer.Simple( 0.1, self.SetScoped, self, false )
	
	if CLIENT then
		self.UL = surface.GetTextureID( "HUD/scope_sniper_ul")
		self.UR = surface.GetTextureID( "HUD/scope_sniper_ur")
		self.LL = surface.GetTextureID( "HUD/scope_sniper_ll")
		self.LR = surface.GetTextureID( "HUD/scope_sniper_lr")
		self.Dot = surface.GetTextureID( "sprites/redglow1" )
	end
end

function SWEP:SetScoped( bool )
	if SERVER then
		self.Weapon:SetNWBool( "scoped", bool )
		self.Scoped = bool
		if bool then
			self.Weapon:SetNWInt( "startscope", CurTime() )
			self.StartScope = CurTime()
			self.Owner:SetFOV( 20 )
			GAMEMODE:SetPlayerSpeed( self.Owner, 80, 80 )
			if SERVER then self.Owner:SprintDisable() end
		else
			GAMEMODE:SetPlayerSpeed( self.Owner, 250, 500 )
			if SERVER then self.Owner:SprintEnable() end
			self.StartScope = false
			self.Owner:SetFOV( 90 )
		end
	end
end
function SWEP:CSShootBullet( dmg, recoil, numbul, cone, force )
	
	numbul 	= numbul 	or 1
	cone 	= cone 		or 0.01
	
	local bullet = {}
	bullet.Num 		= numbul
	bullet.Src 		= self.Owner:GetShootPos()			// Source
	bullet.Dir 		= self.Owner:GetAimVector()			// Dir of bullet
	bullet.Spread 	= Vector( cone, cone, 0 )			// Aim Cone
	bullet.Tracer	= 1									// Show a tracer on every x bullets 
	bullet.Force	= force									// Amount of force to give to phys objects
	bullet.Damage	= dmg
	
	self.Owner:FireBullets( bullet )
	self.Weapon:SendWeaponAnim( ACT_VM_PRIMARYATTACK ) 		// View model animation
	self.Owner:MuzzleFlash()								// Crappy muzzle light
	self.Owner:SetAnimation( PLAYER_ATTACK1 )				// 3rd Person Animation
	self.NextPrimaryFire = CurTime() + 1.5
	self.Weapon:EmitSound( self.Primary.Sound )
	timer.Simple( 0.5, self.SetScoped, self, false )
	self:TakePrimaryAmmo( 1 )
	
end
function SWEP:GetScoped()
	if SERVER then
		return self.Scoped 
	else
		return self.Weapon:GetNWBool( "scoped" )
	end
end
function SWEP:CanPrimaryAttack()
	if self.Weapon:Clip1() > 0 && self.NextPrimaryFire < CurTime() then
		return true
	end
	self.Weapon:EmitSound( Sound( "Weapon_SniperRifle.ClipEmpty" ) )
	return false
end
