

if ( SERVER ) then

	AddCSLuaFile( "shared.lua" )
	
end

if ( CLIENT ) then

	SWEP.PrintName			= "Medic's Dartgun"			
	SWEP.Author				= "The Mathias"
	SWEP.Slot				= 3
	SWEP.SlotPos			= 1
	SWEP.IconLetter			= "z"
	
	killicon.AddFont( "weapon_grenadelauncher", "CSKillIcons", SWEP.IconLetter, Color( 255, 80, 0, 255 ) )
	
end


//SWEP.Base				= "weapon_cs_base"
SWEP.Category			= "Team Fortress 2"

SWEP.Spawnable			= true
SWEP.AdminSpawnable		= true

SWEP.ViewModel			= "models/weapons/v_models/v_syringegun_medic.mdl"
SWEP.WorldModel			= "models/weapons/w_models/w_syringegun.mdl"

SWEP.Weight				= 5
SWEP.AutoSwitchTo		= false
SWEP.AutoSwitchFrom		= false

SWEP.Primary.Sound			= Sound( "Weapon_SyringeGun.Single" )
SWEP.Primary.ClipSize		= 40
SWEP.Primary.Delay			= 0.1
SWEP.Primary.DefaultClip	= 50
SWEP.Primary.Automatic		= true
SWEP.Primary.Ammo			= "smg1"

SWEP.Secondary.ClipSize		= -1
SWEP.Secondary.DefaultClip	= -1
SWEP.Secondary.Automatic	= false
SWEP.Secondary.Ammo			= "none"

function SWEP:Initialize()
	if SERVER then self:SetWeaponHoldType( "smg" ) end
end

function SWEP:PrimaryAttack()
	
	self.Weapon:SetNextPrimaryFire( CurTime() + self.Primary.Delay )
	
	if self.Weapon:Clip1() <= 0 then
		self:Reload()
		return
	end
	
	if ( !self:CanPrimaryAttack() ) then return end
	
	self.Weapon:EmitSound( self.Primary.Sound )
	
	self.Weapon:SendWeaponAnim( ACT_VM_PRIMARYATTACK ) 
	self:TakePrimaryAmmo( 1 )
	
	if CLIENT then return end

	local Syringe = ents.Create("syringe")
	Syringe:SetPos( self.Owner:GetShootPos() + ( self.Owner:GetAimVector() * 40 ) )
	Syringe:SetAngles( self.Weapon:GetAngles() + Angle( 90, 0, 0 ) )
	Syringe:Spawn()
	Syringe:Activate()
	Syringe.Owner = self.Owner
	
	Syringe:GetPhysicsObject():ApplyForceCenter( self.Owner:GetAimVector() * 5000 )
	
end

function SWEP:Reload()
	self.Weapon:DefaultReload( ACT_VM_RELOAD );
end

function SWEP:Deploy()
	self.Weapon:EmitSound( Sound( "Weapon_SyringeGun.Draw" ) )
end

function SWEP:SecondaryAttack()
end
